package org.gcube.portlets.widgets.ckancontentmoderator.shared;

import java.io.Serializable;

import org.gcube.datacatalogue.utillibrary.shared.ItemStatus;

import com.google.gwt.user.client.rpc.IsSerializable;


/**
 * The Class CatalogueDataset.
 *
 * @author Francesco Mangiacrapa at ISTI-CNR francesco.mangiacrapa@isti.cnr.it
 * 
 *         Jun 14, 2021
 */
public class CatalogueDataset implements Serializable, IsSerializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 566645830900736239L;
	private String author;
	private String authorEmail;
	private String id;
	private String licenseId;
	private String maintainer;
	private String maintainerEmail;
	private String name;
	private String notes;
	private String ownerOrg;
	private ItemStatus status;
	private String title;
	private String type;
	private String url;
	private String version;
	private String d4scienceItemURL;
	private long created;

	/**
	 * Instantiates a new ckan dataset base.
	 */
	public CatalogueDataset() {
	}

	public String getAuthor() {
		return author;
	}

	public String getAuthorEmail() {
		return authorEmail;
	}

	public String getId() {
		return id;
	}

	public String getLicenseId() {
		return licenseId;
	}

	public String getMaintainer() {
		return maintainer;
	}

	public String getMaintainerEmail() {
		return maintainerEmail;
	}

	public String getName() {
		return name;
	}

	public String getNotes() {
		return notes;
	}

	public String getOwnerOrg() {
		return ownerOrg;
	}

	public ItemStatus getStatus() {
		return status;
	}

	public String getTitle() {
		return title;
	}

	public String getType() {
		return type;
	}

	public String getUrl() {
		return url;
	}

	public String getVersion() {
		return version;
	}

	public String getD4scienceItemURL() {
		return d4scienceItemURL;
	}

	public long getCreated() {
		return created;
	}

	public void setAuthor(String author) {
		this.author = author;
	}

	public void setAuthorEmail(String authorEmail) {
		this.authorEmail = authorEmail;
	}

	public void setId(String id) {
		this.id = id;
	}

	public void setLicenseId(String licenseId) {
		this.licenseId = licenseId;
	}

	public void setMaintainer(String maintainer) {
		this.maintainer = maintainer;
	}

	public void setMaintainerEmail(String maintainerEmail) {
		this.maintainerEmail = maintainerEmail;
	}

	public void setName(String name) {
		this.name = name;
	}

	public void setNotes(String notes) {
		this.notes = notes;
	}

	public void setOwnerOrg(String ownerOrg) {
		this.ownerOrg = ownerOrg;
	}

	public void setStatus(ItemStatus status) {
		this.status = status;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public void setType(String type) {
		this.type = type;
	}

	public void setUrl(String url) {
		this.url = url;
	}

	public void setVersion(String version) {
		this.version = version;
	}

	public void setD4ScienceItemURL(String d4scienceItemURL) {
		this.d4scienceItemURL = d4scienceItemURL;
	}

	public void setCreated(long created) {
		this.created = created;
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("CatalogueDataset [author=");
		builder.append(author);
		builder.append(", authorEmail=");
		builder.append(authorEmail);
		builder.append(", id=");
		builder.append(id);
		builder.append(", licenseId=");
		builder.append(licenseId);
		builder.append(", maintainer=");
		builder.append(maintainer);
		builder.append(", maintainerEmail=");
		builder.append(maintainerEmail);
		builder.append(", name=");
		builder.append(name);
		builder.append(", notes=");
		builder.append(notes);
		builder.append(", ownerOrg=");
		builder.append(ownerOrg);
		builder.append(", status=");
		builder.append(status);
		builder.append(", title=");
		builder.append(title);
		builder.append(", type=");
		builder.append(type);
		builder.append(", url=");
		builder.append(url);
		builder.append(", version=");
		builder.append(version);
		builder.append(", d4scienceItemURL=");
		builder.append(d4scienceItemURL);
		builder.append(", created=");
		builder.append(created);
		builder.append("]");
		return builder.toString();
	}

}